searchNodes=[{"doc":"Top level module providing Beamchmark.run API. Beamchmark measures EVM performance while it is running user Beamchmark.Scenario . Metrics being measured Scheduler Utilization At the moment, the main interest of Beamchmark is scheduler utilization which tells how much given scheduler was busy. Scheduler is busy when: Executing process code Executing linked-in driver or NIF code Executing BIFs, or any other runtime handling Garbage collecting Handling any other memory management Scheduler utilization is measured using Erlang's :scheduler module which uses :erlang.statistics/1 under the hood and it is represented as a floating point value between 0.0 and 1.0 and percent. Beamchmark measures following types of scheduler utilization: normal/cpu/io - average utilization of single scheduler of given type total normal/cpu/io - average utilization of all schedulers of given type. E.g total normal equals 1.0 when each of normal schedulers have been acive all the time total - average utilization of all schedulers weighted - average utilization of all schedulers weighted against maximum amount of available CPU time For more information please refer to :erlang.statistics/1 (under :scheduler_wall_time ) or :scheduler.utilization/1 . Other Other metrics being measured: reductions - total reductions number context switches - total context switches number","ref":"Beamchmark.html","title":"Beamchmark","type":"module"},{"doc":"Runs scenario and benchmarks EVM performance. Subsequent invocation of this function will also compare results with the previous ones.","ref":"Beamchmark.html#run/2","title":"Beamchmark.run/2","type":"function"},{"doc":"Configuration for Beamchmark . duration - time in seconds Beamchmark will be benchmarking EVM. Defaults to 60 seconds. delay - time in seconds Beamchmark will wait after running scenario and before starting benchmarking. output_dir - directory where results of benchmarking will be saved.","ref":"Beamchmark.html#t:options_t/0","title":"Beamchmark.options_t/0","type":"type"},{"doc":"Scenario to run during benchmarking","ref":"Beamchmark.Scenario.html","title":"Beamchmark.Scenario","type":"behaviour"},{"doc":"","ref":"Beamchmark.Scenario.html#c:run/0","title":"Beamchmark.Scenario.run/0","type":"callback"},{"doc":"Tool for measuring EVM performance. At the moment, the main interest of Beamchmark is scheduler utilization, reductions and context switches number. For more information please refer to API docs.","ref":"readme.html","title":"Beamchmark","type":"extras"},{"doc":"Beamchmark should be used when you want to measure BEAM performance while it is runing your application. Benchee should be used when you want to benchmark specific function from your code base. In particular, Benchee will inform you how long your function is executing while Beamchmark will inform you how busy BEAM is.","ref":"readme.html#beamchmark-and-benchee","title":"Beamchmark - Beamchmark and Benchee","type":"extras"},{"doc":"The package can be installed by adding beamchmark to your list of dependencies in mix.exs : def deps do [ { :beamchmark , &quot;~&gt; 0.1.1&quot; } ] end","ref":"readme.html#installation","title":"Beamchmark - Installation","type":"extras"},{"doc":"To run example type: mix run examples/&lt;example_name&gt;.exs Example output &gt; mix run examples/advanced.exs Running scenario Waiting 1 seconds Benchmarking ================ SYSTEM INFO ================ System version: Erlang/OTP 24 [erts-12.0.3] [source] [64-bit] [smp:8:8] [ds:8:8:10] [async-threads:1] [jit] System arch: x86_64-pc-linux-gnu NIF version: 2.16 ================ BASE ================ Normal schedulers -------------------- 1 1.0668080386966647e-4 0.0% 2 7.998836416749597e-5 0.0% 3 4.2106493950736044e-4 0.0% 4 3.639672738461754e-7 0.0% 5 4.7350414264111834e-4 0.0% 6 0.0043860455491825795 0.4% 7 8.102830226995653e-5 0.0% 8 1.6912821965950098e-4 0.0% Total: 7.147255360714405e-4 0.1% CPU schedulers -------------------- 9 0.0 0.0% 10 0.0 0.0% 11 0.0 0.0% 12 0.0 0.0% 13 0.0 0.0% 14 0.0 0.0% 15 0.0 0.0% 16 0.006471963981908292 0.6% Total: 8.089954977385365e-4 0.1% IO schedulers -------------------- Total: 0 0% Weighted -------------------- 0.001523719527435532 0.2% Reductions -------------------- 11661549 Context Switches -------------------- 30602 ================ NEW ================ Normal schedulers -------------------- 1 3.089102038763749e-4 0.0% 2.0222940000670843e-4 0% 2 3.782341555965018e-4 0.0% 2.982457914290058e-4 0% 3 3.6955770413050143e-6 0.0% -4.1736936246605544e-4 0% 4 1.6818640195259216e-4 0.0% 1.67822434678746e-4 0% 5 3.98059971168814e-4 0.0% -7.544417147230432e-5 0% 6 2.6124825293454316e-4 0.0% -0.004124797296248036 -100% 7 0.005979264520280537 0.6% 0.00589823621801058 nan 8 1.3163673613384656e-4 0.0% -3.749148352565442e-5 0% Total: 9.536544773730643e-4 0.1% 2.389289413016238e-4 0% CPU schedulers -------------------- 9 0.0 0.0% 0.0 0% 10 0.0 0.0% 0.0 0% 11 0.0 0.0% 0.0 0% 12 0.0 0.0% 0.0 0% 13 0.0 0.0% 0.0 0% 14 0.0 0.0% 0.0 0% 15 0.0 0.0% 0.0 0% 16 0.005779059586476821 0.6% -6.929043954314717e-4 0% Total: 7.223824483096026e-4 0.1% -8.661304942893396e-5 0% IO schedulers -------------------- Total: 0 0% 0 0% Weighted -------------------- 0.0016760349343240095 0.2% 1.5231540688847743e-4 0% Reductions -------------------- 23727211 12065662 103.46534581297905% Context Switches -------------------- 38717 8115 26.517874648715775% Results successfully saved to &quot;/tmp/beamchmark_output/new&quot; directory","ref":"readme.html#usage","title":"Beamchmark - Usage","type":"extras"},{"doc":"Copyright 2021, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Beamchmark - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]